  'This program will completely cipher any other program
  'using the syntax CIPHER [filename] [password].  Using
  'the SAME syntax and password again will uncipher the program.
  'Will work on all types from .EXE's to .TXT's to ZIP's.
  'The PDQ library from Crescent Software was used to
  'reduce the final executable size down to 5k, but it can
  'be compiled in either the QB4.00b envirnoment or .EXE'd

  'Bill Weiss  Paramus, NJ     02/02/90
  '201-262-3275

  '#EXEpath: 'C:\QB4\PDQ'
  '#EXEName: 'CIPHER'
  '#CompilerName: 'BC'
  '#CompileSwitches: '/O'
  '#LinkSwitches: '/NOD'
  '#SourceExtension: 'BAS'
  '#ObjectExtension: 'OBJ'
  '#Libraries: 'C:\LIBS\ALL.LIB'
  '#Libraries: 'C:\LIBS\PDQ.LIB'
  '#SourcePath: 'C:\QB4\PDQ'
  '#ObjectPath: 'C:\LIBS'
  '#IncludePath: 'C:\LIBS'

  DEFINT A-Z
  CONST BYTES = 2048
  CONST ini = 1

  DECLARE FUNCTION Rand& ()
  DECLARE FUNCTION RandInteger% (a%, b%)
  DECLARE SUB RandShuffle (key$)
  DECLARE SUB ProcesX (a$)

  DIM SHARED r&(1 TO 100)

  PRINT "CIPHER "; COMMAND$
  PRINT

  cmd$ = COMMAND$

  IF cmd$ = "" THEN
    PRINT
    PRINT "Usage:  CIPHER filename key-string"
    PRINT
    SYSTEM
  END IF

  cmd$ = cmd$ + " "
  firstSpace% = INSTR(cmd$, " ")
  fileName$ = LEFT$(cmd$, firstSpace% - ini)

  key$ = LTRIM$(MID$(cmd$, firstSpace% + ini))

  RandShuffle key$

  OPEN fileName$ FOR BINARY AS #1
  fileLength& = LOF(1)

  a$ = SPACE$(BYTES)
  count% = fileLength& \ BYTES

  FOR i% = 0 TO count%
    j& = i% * BYTES + ini
    IF i% = count% THEN
      a$ = SPACE$(fileLength& - BYTES * count%)
    END IF
    GET #1, j&, a$
    ProcesX a$
    PUT #1, j&, a$
  NEXT

  SYSTEM

SUB ProcesX (a$) STATIC
  FOR i% = ini TO LEN(a$)
    byte% = ASC(MID$(a$, i%, ini)) XOR RandInteger%(0, 255)
    MID$(a$, i%, ini) = CHR$(byte%)
  NEXT
END SUB

FUNCTION Rand& STATIC

  i% = r&(98)
  j% = r&(99)

  t& = r&(i%) - r&(j%)

  IF t& < 0 THEN
    t& = t& + 1000000000
  END IF

  r&(i%) = t&

  IF i% > ini THEN
    r&(98) = i% - ini
  ELSE
    r&(98) = 55
  END IF

  IF j% > ini THEN
    r&(99) = j% - ini
  ELSE
    r&(99) = 55
  END IF

  i% = r&(100) MOD 42 + 56

  r&(100) = r&(i%)

  r&(i%) = t&

  Rand& = r&(100)

END FUNCTION

FUNCTION RandInteger% (a%, b%) STATIC
  RandInteger% = a% + (Rand& MOD (b% - a% + ini))
END FUNCTION

DEFSNG A-Z
SUB RandShuffle (key$) STATIC

  k$ = LEFT$("Abra Ca Da Bra" + key$ + SPACE$(83), 97)

  FOR i% = ini TO 97
    r&(i%) = ASC(MID$(k$, i%, ini)) * 8171717 + i% * 997&
  NEXT

  k$ = ""

  i% = 97
  j% = 12

  FOR k% = ini TO 997

    r&(i%) = r&(i%) - r&(j%)

    IF r&(i%) < 0 THEN
      r&(i%) = r&(i%) + 1000000000
    END IF

    IF i% > ini THEN
      i% = i% - ini
    ELSE
      i% = 97
    END IF

    IF j% > ini THEN
      j% = j% - ini
    ELSE
      j% = 97
    END IF

  NEXT

  r&(98) = 55
  r&(99) = 24

  r&(100) = 77

END SUB

